#!/bin/bash

rm -f users-created.log                   # Log-Datei löschen
while read zeile; do
  # passt Zeile auf Muster Nachname:Vorname:MatrNr ?
  [[ $zeile =~ ^[^:]+:[^:]+:[^:]+$ ]] || continue

  # Bestandteile der Zeile
  nachname=$( echo $zeile | sed -E 's/^([^:]+):.*/\1/' )
  vorname=$(  echo $zeile | sed -E 's/^[^:]+:([^:]+):.*/\1/' )
  matriknr=$( echo $zeile | sed -E 's/^[^:]+:[^:]+:([^:]+)$/\1/' )

  # erste 2 / 3 Zeichen von Vor/Nachname; alles klein
  n=$( echo $nachname | cut -c 1-3 | tr A-Z a-z )
  v=$( echo $vorname  | cut -c 1-2 | tr A-Z a-z )
  u=$v$n                                  # Username
  k="$vorname $nachname, $matriknr"       # Kommentarfeld
  p=$( pwgen 8 1 )                        # Passwort

  sudo useradd -m -c "$k" $u              # Konto anlagen
  echo "$u:$p" | sudo chpasswd            # Passwort setzen
  echo $zeile:$u:$p >> users-created.log  # Log-Eintrag
done < users.conf     # ganze Schleife liest aus Konfigdatei

